#!/usr/local/bin/perl
# connect.cgi
# Attempt a connection to the Internet with wvdial, and show the results

require './ppp-client-lib.pl';
&ReadParse();
$theme_no_table++;
$| = 1;
&header($text{'connect_title'}, "");
print "<hr>\n";

# Get this dialer's configuration
$conf = &get_config();
($dialer) = grep { lc($_->{'name'}) eq lc($in{'section'}) } @$conf;
($ddialer) = grep { lc($_->{'name'}) eq 'dialer defaults' } @$conf;
if ($inherits = $dialer->{'values'}->{'inherits'}) {
	($parent) = grep { lc($_->{'name'}) eq lc($inherits) } @$conf;
	}
$autodns = $dialer->{'values'}->{'auto dns'} ?
		($dialer->{'values'}->{'auto dns'} =~ /on|yes|1/ ? 1 : 0) :
	   $parent->{'values'}->{'auto dns'} ?
		($parent->{'values'}->{'auto dns'} =~ /on|yes|1/ ? 1 : 0) :
	   $ddialer->{'values'}->{'auto dns'} ?
		($ddialer->{'values'}->{'auto dns'} =~ /on|yes|1/ ? 1 : 0) :
		1;

# Run wvdial, writing to a temp file in the background
$stime = time();
$sect = $in{'section'};
$sect =~ s/^Dialer\s+//;
$temp = &tempname();
if (!($pid = fork())) {
	untie(*STDIN);
	untie(*STDOUT);
	untie(*STDERR);
	open(STDOUT, ">$temp");
	open(STDERR, ">&STDOUT");
	open(STDIN, "/dev/null");
	exec($config{'wvdial'}, $sect);
	exit(1);
	}
while (!open(TEMP, $temp)) { }
&additional_log("exec", undef, "$config{'wvdial'} $sect");
unlink($temp);

# Read output until success or failure
print "<p><b>",&text('connect_cmd',
		     "<tt>$config{'wvdial'} $sect</tt>"),"</b><br>\n";
print "<pre>";
while(1) {
	$line = &wait_for_line();
	print &html_escape($line);
	if ($line =~ /IP\s+address\s+is\s+(\d+\.\d+\.\d+\.\d+)/i) {
		# Connected OK!
		$connected = $1;
		last;
		}
	elsif ($line =~ /starting\s+ppp/i) {
		# Connected in stupid mode
		$connected = "*";
		last;
		}
	elsif (!$line) {
		# Program terminated .. must have failed!
		$failed++;
		last;
		}
	}
print "</pre>\n";

# If OK, save the PID for later
if ($connected) {
	print "<b>",$connected eq '*' ? $text{'connect_noip'} :
			&text('connect_ip', "<tt>$connected</tt>"),"</b><p>\n";
	&save_connect_details($connected, $pid, $in{'section'});
	}
else {
	print "<b>$text{'connect_failed'}</b><p>\n";
	}
$config{'dialer'} = $in{'section'};
&lock_file("$module_config_directory/config");
&write_file("$module_config_directory/config", \%config);
&unlock_file("$module_config_directory/config");

if ($connected && $autodns) {
	# If the resolv.conf file has not been modified, and the PPP
	# resolv.conf has, copy it into place
	while(1) {
		sleep(3);
		($ip, $pid, $sect) = &get_connect_details();
		if (!$pid || !kill(0, $pid)) {
			# Connection is down .. DNS will never be updated
			print "<b>$text{'connect_dnsdown'}</b><p>\n";
			last;
			}
		$now = time();
		if ($now > $stime+60) {
			# Took too long to update DNS
			print "<b>$text{'connect_dnsto'}</b><p>\n";
			last;
			}
		@pst = stat($ppp_resolv_conf);
		@ost = stat($resolv_conf);
		if ($ost[9] >= $stime) {
			# Something else has update the DNS config ..
			print "<b>$text{'connect_dns2'}</b><p>\n";
			last;
			}
		if ($pst[9] >= $stime) {
			# A PPP DNS config has been created .. use it
			&system_logged("cp $resolv_conf $save_resolv_conf")
				if (!-l $resolv_conf);
			unlink($resolv_conf);
			&system_logged("cp $ppp_resolv_conf $resolv_conf");
			print "<b>$text{'connect_dns'}</b><p>\n";
			last;
			}
		}
	}

&webmin_log("connect", $in{'section'}, $connected);
print "<hr>\n";
&footer("", $text{'index_return'});

# wait_for_line()
# Reads a line from the temp file, or waits if there is no more to read. Only
# returns undef if the process has died
sub wait_for_line
{
local $line = <TEMP>;
return $line if ($line);
waitpid($pid, 1);
return undef if (!kill(0, $pid));
sleep(1);
return &wait_for_line();
}

